// Copyright (C) 2019  Wilko Manger
//
// This file is part of matrix-dart-sdk.
//
// matrix-dart-sdk is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// matrix-dart-sdk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with matrix-dart-sdk.  If not, see <https://www.gnu.org/licenses/>.
library matrix;

export 'src/homeserver.dart';
export 'src/user.dart';
export 'src/exception.dart';
export 'src/identifier.dart';

export 'src/storables.dart';

export 'src/room/room.dart';
export 'src/room/rooms.dart';

export 'src/event/event.dart';
export 'src/event/timeline.dart';

export 'src/event/room/room_event.dart';

export 'src/event/room/message_event.dart';
export 'src/event/room/redaction_event.dart';

export 'src/event/room/state/state_event.dart';
export 'src/event/room/state/room_creation_event.dart';
export 'src/event/room/state/room_avatar_change_event.dart';
export 'src/event/room/state/member_change_event.dart';
export 'src/event/room/state/room_name_change_event.dart';
export 'src/event/room/state/room_upgrade_event.dart';
export 'src/event/room/state/topic_change_event.dart';
export 'src/event/room/state/power_levels_change_event.dart';

export 'src/store.dart';

export 'src/util/json.dart';
