// Copyright (C) 2019  Wilko Manger
//
// This file is part of matrix-dart-sdk.
//
// matrix-dart-sdk is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// matrix-dart-sdk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with matrix-dart-sdk.  If not, see <https://www.gnu.org/licenses/>.

import 'package:matrix_sdk/src/event/event.dart';
import 'package:matrix_sdk/src/event/room/room_event.dart';

abstract class StateEvent extends RoomEvent {
  @override
  StateEventContent get content;

  final String stateKey;

  StateEvent(RoomEventArgs args, {this.stateKey = ''}) : super(args);

  @override
  Map<String, dynamic> toJson() =>
      super.toJson()..addAll({'state_key': stateKey});
}

abstract class StateEventContent extends EventContent {
  final String stateKey = '';
}

/// @internal
bool hasStateKey(dynamic json) => json.containsKey('state_key');
