// Copyright (C) 2019  Wilko Manger
//
// This file is part of matrix-dart-sdk.
//
// matrix-dart-sdk is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// matrix-dart-sdk is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with matrix-dart-sdk.  If not, see <https://www.gnu.org/licenses/>.

import 'package:matrix_sdk/matrix_sdk.dart';
import 'package:test/test.dart';

void main() {
  group('Identifier validity', () {
    test('UserId', () {
      assert(Username.isValid('michael-scott'));
      assert(Username.isValid('pit_pattle'));
      assert(Username.isValid('joe'));

      assert(!Username.isValid('#\$^%\$43#\$^'));
      assert(!Username.isValid('wil@ko'));
      assert(!Username.isValid('@matthew'));
    });

    test('Username', () {
      assert(!UserId.isValidFullyQualified('#\$^%\$43#\$^'));
      assert(!UserId.isValidFullyQualified('@pit'));
      assert(!UserId.isValidFullyQualified('pit'));
      assert(!UserId.isValidFullyQualified('pi&*3t'));
      assert(!UserId.isValidFullyQualified('pi&*3:t.tk'));

      assert(UserId.isValidFullyQualified('@pit:pattle.im'));
      assert(UserId.isValidFullyQualified('@joe:matrix.org'));
      assert(UserId.isValidFullyQualified('@jim:192.168.0.1'));
      assert(UserId.isValidFullyQualified('@jim:192.168.0.1:9043'));
    });
  });

  // TODO: Add proper unit testing
}
